package cn.com.tenlion.systembase.util.fullsync;

import cn.com.tenlion.systembase.pojo.dtos.enterprise.EnterpriseDTO;
import cn.com.tenlion.systembase.pojo.vos.enterprise.EnterpriseVO;
import cn.com.tenlion.systembase.service.enterprise.IEnterpriseService;
import com.alibaba.fastjson.JSONObject;
import ink.wgink.exceptions.SearchException;
import org.apache.kafka.clients.consumer.ConsumerRecord;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.ApplicationEventPublisher;
import org.springframework.context.ApplicationEventPublisherAware;
import org.springframework.kafka.annotation.KafkaListener;
import org.springframework.kafka.core.KafkaTemplate;
import org.springframework.stereotype.Component;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * 表单全量数据同步
 * 接收数据整合系统发来的全量数据同步命令, 向数据整合系统发送表单的全部数据
 */
@Component
public class FullSyncC0014 implements ApplicationEventPublisherAware {

    private ApplicationEventPublisher applicationEventPublisher;
    @Autowired
    private IEnterpriseService enterpriseService;
    @Autowired
    KafkaTemplate kafkaTemplate;

    public FullSyncC0014() {}

    @KafkaListener(topics = "C0014FullSync")
    public void message(ConsumerRecord<?, ?> record) {
        System.out.println("收到全量同步命令");
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        System.out.println(jsonObject.toJSONString());// 表单编号
        System.out.println(jsonObject.getString("tableNumber"));// 表单编号
        System.out.println(jsonObject.getInteger("tableDataCount"));// 整合系统数据量
        /**
         * 1 . 查询本地数据的数量 , 如果本地数据量 > 整合系统数据量
         * 2 . 查询数据库中所有的事件列表
         * 3 . 遍历事件, 封装数据
         * 4 . 发送新增案件消息
         */
        Map<String, Object> params = new HashMap<>();
        List<EnterpriseDTO> enterpriseDTOList = enterpriseService.list(params);
        System.out.println(enterpriseDTOList.size());
        if(null != enterpriseDTOList && enterpriseDTOList.size() > 0) {
            for(EnterpriseDTO enterpriseDTO: enterpriseDTOList) {
                EnterpriseVO enterpriseVO = setData(enterpriseDTO);
                enterpriseService.saveKafka(enterpriseDTO.getEnterpriseId(), enterpriseVO);
            }
        }
    }

    @KafkaListener(topics = "C0014")
    public void messageMsg(ConsumerRecord<?, ?> record) {
        JSONObject jsonObject = JSONObject.parseObject(record.value().toString());
        Map<String, Object> params = new HashMap<>();
        if(!"delete".equals(jsonObject.getString("action"))) {
            EnterpriseDTO enterpriseDTO = enterpriseService.get(jsonObject.getString("uid"));
            EnterpriseVO enterpriseVO = setData(enterpriseDTO);
            enterpriseService.saveKafka(enterpriseDTO.getEnterpriseId(), enterpriseVO);
        }else {
            enterpriseService.deleteKafka(jsonObject.getString("uid"));
        }
    }

    private EnterpriseVO setData(EnterpriseDTO enterpriseDTO) {
        if(null == enterpriseDTO) {
            throw new SearchException("当前对象为空,请注意查看");
        }
        EnterpriseVO enterpriseVO = new EnterpriseVO();
        enterpriseVO.setEnterpriseName(enterpriseDTO.getEnterpriseName());
        enterpriseVO.setEnterpriseTypeName(enterpriseDTO.getEnterpriseTypeName());
        enterpriseVO.setEnterpriseAddress(enterpriseDTO.getEnterpriseAddress());
        enterpriseVO.setAreaCode(enterpriseDTO.getAreaCode());
        enterpriseVO.setEnterpriseLng(enterpriseDTO.getEnterpriseLng());
        enterpriseVO.setEnterpriseLat(enterpriseDTO.getEnterpriseLat());
        enterpriseVO.setGridName(enterpriseDTO.getGridName());
        enterpriseVO.setGridCode(enterpriseDTO.getGridCode());
        return enterpriseVO;
    }

    @Override
    public void setApplicationEventPublisher(ApplicationEventPublisher applicationEventPublisher) {
        this.applicationEventPublisher = applicationEventPublisher;
    }

}